﻿/*
* kner 2015
* key debounce version 2 (dont use it)
* problem: bounce as well on pressing as on releasing the button 
*
* Bad: block the interrupt for 30ms
*
* connect a button on Arduino Pin 2 to GND
*/

#include <Arduino.h>

#define DEBUG_LCD
#include "_debug.h"

int g;
int pendingInterrupsCounter;
ISR(INT0_vect){
	M(pendingInterrupsCounter)
	//wait a little
	WAIT_MS(30);
	//check the key
	if (digitalRead(2) == LOW){
			L(g);g++;            //count the number of key pressures
	}
	//clear pending Interrupts
	if (EIFR & _BV(INTF0)){
		  EIFR = _BV(INTF0);
		  pendingInterrupsCounter++; 
	}
}
void setup()
{   //kill Arduino Timer0 Interrupt;  millis() not available!
	TIMSK0 &=~_BV(TOIE0);
	
	EICRA |= _BV(ISC01); //Falling edge
	EIMSK |= _BV(INT0); //enable external Interrupt 0
	
	pinMode(2,INPUT_PULLUP); //ext. Interrupt
}

void loop()
{
	volatile static int dummy=0; dummy++;  //needed for simulator if no additional lines of code
}



