﻿/*
* kner 2015
* key debounce version 4 (usable)
* problem: the buttons bounce as well on pressing as on releasing the button
*
* 
* Good: no isr
* connect a button on Arduino Pin 2 to GND
* graphics for statemachine within project directory
*/

#include <Arduino.h>
#define DEBUG_LCD
#include "_debug.h"
int keypressed(); // non blocking incl. debounce

void setup()
{
	pinMode(2,INPUT_PULLUP); //ext. Interrupt
	//TIMSK0 &=~_BV(TOIE0);//millis() needed
}

void loop()
{   volatile static int dummy=0; dummy++;  //needed for simulator if no additional lines of code
	static int x=0;
	if (keypressed()){
		TDEC(x)
		x++;
	}
}

int keypressed1(){
	// non blocking incl. debounce statemachine

	static int state=0;
	static int nextstate=0;
	static unsigned long bouncetime;
	int out1=0;
	int key=digitalRead(2);
	if (state == 0 && key == 1 ){
		nextstate=0;
		out1=0;
	}
	else if (state == 0 && key == 0 ){
		nextstate=1;
		bouncetime = millis();
		out1=0;
		T("S0")
	}
	else if (state == 1 && (((millis()-bouncetime) > 30))){
		nextstate=2;
		out1=0;
		T("S1")
	}
	else if (state == 2 && key == 0 ){
		nextstate=2;
		out1=0;
		T("S2a")
	}
	else if (state == 2 && key == 1 ){
		nextstate=3;
		out1=0;
		T("S2b")
	}
	else if (state == 3){
		nextstate=0;
		out1=1;
		T("S3")
	}
	state=nextstate;
	return out1;
}

int keypressed(){
	// non blocking incl. debounce statemachine

	static int state=0;
	static unsigned long bouncetime;
	int out1=0;
	int key=digitalRead(2);
	switch (state){
		case 0:
		out1=0;
		if ( key == 1 ) state=0;
		else {
			state=1;
			bouncetime = millis();
		}
		break;
		case 1:
		out1=0;
		if ((millis()-bouncetime) > 30){
			state=2;
		}
		break;
		case 2:
		out1=0;
		if (key == 0 ){
			state=2;
		}
		else {
			state=3;
		}
		break;
		case 3: {
			state=0;
			out1=1;
			break;
		}
		default:;
	}
	return out1;

}



